<?php
/**
 * Gallery2_Menalto by Shirka (http://www.shirka.org)
 *
 * A plugin for the e107 Website System (http://e107.org)
 *
 * Andre DUCLOS 2008
 * http://www.shirka.org
 * duclos@shirka.org
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * $Source: /home/e-smith/files/ibays/cvsroot/files/gallery2m/event_handler.php,v $
 * $Revision: 1.1.1.1 $
 * $Date: 2008/01/01 01:23:33 $
 * $Author: admin $
 */

require_once(e_BASE."class2.php");
require_once(e_PLUGIN."gallery2m/gallery2_class.php");

include_lan(e_PLUGIN."gallery2m/languages/".e_LANGUAGE."/lan_gallery2m.php");

//////////////////////////////////////////////////////
// Pre user settings changed
// This event is triggered prior to updating the user settings in the database. 
// Any return value will halt the update and display the return value. 
//////////////////////////////////////////////////////
function gallery2_preuserset($data) 
{
	global $pref;

	if ($pref['g2mOptions']['Userint'] == 0)
		return;

	$gallery2 = new gallery2_class();
	$error = "";

	// if the userid is not in data it has to be the active user
	$userid = $data['_uid'] ? $data['_uid'] : USERID;

	// load the gallery user data
	list ($id, $g2user) = $gallery2->e107_LoadUserData("user_id = ".$userid);

	// Initialize gallery2 embedding
	if(!$gallery2->g2_Init())
	{
		$lng = new language;

		// build the gallery user data with the new user data
		if(isset($data['loginname']))
			$g2user['username'] = $data['loginname'];
		if(isset($data['email']))
			$g2user['email']    = $data['email'];
		if(isset($data['loginname']))
			$g2user['fullname'] = $data['username'];
		if(isset($data['ue']['user_language']))
			$g2user['language'] = $lng->convert($data['ue']['user_language']);

		// Update or Create gallery2 user
		$error = $gallery2->g2_ChangeOrCreateUser($userid, $g2user);

		// Reconnect to e107 database
		$gallery2->g2_Close();

		if ($error)
			$error_msg = LAN_G2M_CLASS_EVENT_ERROR;
	}
	else
		$error_msg = LAN_G2M_G2_NOT_CONFIG;

	if ($error_msg)
		return "<div style='text-align:left;'><br />".$error_msg."<br />".$error."</div>";
}

//////////////////////////////////////////////////////
// User signup (usersup)
// This event is triggered when a user signs up to the site but is at yet unverified.
// See the user signup verification event for that event. 
//////////////////////////////////////////////////////
function gallery2_usersup($data) 
{
	global $error_message, $pref;

	if ($pref['g2mOptions']['Userint'] == 0)
		return;

	$gallery2 = new gallery2_class();
	$error = "";

	// load the gallery user data
	list ($userid, $g2user) = $gallery2->e107_LoadUserData("user_email = '" . $data['email'] . "'");

	$g2user['language'] = $lng->convert(e_LANGUAGE);

	// Initialize gallery2 embedding
	if(!$gallery2->g2_Init())
	{
		// Update or Create gallery2 user
		$error = $gallery2->g2_ChangeOrCreateUser($userid, $g2user);

		// Close gallery2 session
		$gallery2->g2_Close();

		if ($error)
			$error_msg = LAN_G2M_CLASS_EVENT_ERROR;
	}
	else
		$error_msg = LAN_G2M_G2_NOT_CONFIG;

	if ($error_msg)
		$error_message =  "<div style='text-align:left;'><br />".$error_msg."<br />".$error."</div>";
}
?>