<?php
/**
 * Gallery2_Menalto by Shirka (http://www.shirka.org)
 *
 * A plugin for the e107 Website System (http://e107.org)
 *
 * Andre DUCLOS 2008
 * http://www.shirka.org
 * duclos@shirka.org
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * $Source: /home/e-smith/files/ibays/cvsroot/files/gallery2m/gallery2.php,v $
 * $Revision: 1.1.1.1 $
 * $Date: 2008/01/01 01:23:33 $
 * $Author: admin $
 */

/* Test
	g2Uri: /gallery2/public/
	g2Path: /home/e-smith/files/ibays/gallery2/html/public/
*/

require_once("../../class2.php");

include_lan(e_PLUGIN."gallery2m/languages/".e_LANGUAGE."/lan_gallery2m.php");

if(!$sql -> db_Select("plugin", "*", "plugin_path = 'gallery2m' AND plugin_installflag = '1' "))
{
	require_once(HEADERF);
	$ns -> tablerender("", "<b><u>Gallery2:</u>&nbsp;".LAN_G2M_G2_NOT_INSTALLED."</b>");
	require_once(FOOTERF);
	exit;
}

global $gallery2;

require_once(e_PLUGIN."gallery2m/gallery2_class.php");

if(!isset($gallery2))
	$gallery2 = new gallery2_class();

$error_msg = "";
if($gallery2->g2_Init(true))
{
	if(gettype($gallery2->ret) != "object")
		$error_msg = "<b><u>Gallery2:</u>&nbsp;".LAN_G2M_G2_NOT_CONFIG."</b>";
	else
	{
		$activeuser = ($pref['g2mOptions']['Userint'] == 0 || USERID == 'USERID') ? "" : USERID;
		if (($activeuser && $gallery2->ret->getErrorCode() & ERROR_MISSING_OBJECT) > 0)
		{
			list ($userid, $g2user) = $gallery2->e107_LoadUserData("user_id = ".$activeuser);

			$err = $gallery2->g2_ChangeOrCreateUser($userid, $g2user);

			if ($err)
				$error_msg = "<div style='text-align:left;'><br />".LAN_G2M_G2_ERROR."<br />".$error_message."<br />".$err."</div>";
			else
			{
				if($gallery2->g2_Init(true))
					if(gettype($gallery2->g2_Init(true) != "object"))
						$error_msg = "<b><u>Gallery2:</u>&nbsp;".LAN_G2M_G2_NOT_CONFIG."</b>";
					else
						$error_msg = $gallery2->g2_getErrorStr();
			}
		}
		else
			$error_msg = $gallery2->g2_getErrorStr();
	}
};

if ($error_msg)
{
	require_once(HEADERF);
	$ns -> tablerender("", $error_msg);
	require_once(FOOTERF);
	exit;
}

if (!headers_sent())
{
	header('Content-Type: text/html; charset=UTF-8');
}

GalleryCapabilities::set('showSidebarBlocks', $pref['g2mOptions']['Displaysidebar'] == 0 ? false : true);

GalleryCapabilities::set('login' , $pref['g2mOptions']['Displaylogin'] == 0 ? false : true);

GalleryCapabilities::set('defaultAlbumId', $pref['g2mOptions']['defaultAlbumId'] != "" ? $pref['g2mOptions']['defaultAlbumId'] : NULL);

// handle the G2 request 
$gallery2->moddata = GalleryEmbed::handleRequest(); 

//Get Gallery header and add it to the e107 site url
if (isset($gallery2->moddata['headHtml']))
{
	list($title, $css, $javascript) = GalleryEmbed::parseHead($gallery2->moddata['headHtml']);
	define("e_PAGETITLE", "Gallery : $title");
}

$gallery2->g2_Close();

// show error message if isDone is not defined 
if (!isset($gallery2->moddata['isDone'])) 
{
	echo LAN_G2M_GALLERY2_ISDONE;
	exit;
}

// die if it was a binary data (image) request 
if ($gallery2->moddata['isDone']) 
{
	exit; /* uploads module does this too */ 
}

require_once(HEADERF);

echo $gallery2->moddata['bodyHtml'];

require_once(FOOTERF);

?>