<?php
/**
 * Gallery2_Menalto by Shirka (http://www.shirka.org)
 *
 * A plugin for the e107 Website System (http://e107.org)
 *
 * Andre DUCLOS 2008
 * http://www.shirka.org
 * duclos@shirka.org
 *
 * Released under the terms and conditions of the
 * GNU General Public License (http://gnu.org).
 *
 * $Source: /home/e-smith/files/ibays/cvsroot/files/gallery2m/gallery2_class.php,v $
 * $Revision: 1.1.1.1 $
 * $Date: 2008/01/01 01:23:33 $
 * $Author: admin $
 */

@include_once(e_PLUGIN.'gallery2m/languages/'.e_LANGUAGE.'/lan_gallery2m_class.php');
@include_once(e_PLUGIN.'gallery2m/languages/English/lan_gallery2m_class.php');

require_once(e_HANDLER."language_class.php");

class gallery2_class
{
	var $moddata;
	var $blockdata;
	var $ret;

	//////////////////////////////////////////
	// Initialize gallery2 embedding
	//////////////////////////////////////////
	// 'fullInit' => (optional) call GalleryInitSecondPass (only use when not calling handleRequest)
	function g2_Init($fullInit = false)
	{
		global $pref, $PLUGINS_DIRECTORY;

		$this->ret = true;
		if (is_readable($pref['g2mOptions']['Path'] . 'embed.php') == false)
			return true;

		require_once($pref['g2mOptions']['Path'] . 'embed.php');

		$g2EmbedUri = e_HTTP.$PLUGINS_DIRECTORY.'gallery2m/gallery2.php';
	
		// allways use active user or guest as login
		$activeuser = ($pref['g2mOptions']['Userint'] == 0 || USERID == 'USERID') ? "" : USERID;

		// this plugin is build on API Version 1.1
		// ERROR_PLUGIN_VERSION_MISMATCH is returned if your integration is not compatible
		$g2ApiVersion = array(1, 1);
	
		$lng = new language;

		$this->ret = GalleryEmbed::init(array( 
			'g2Uri'		=> $pref['g2mOptions']['Uri'],
			'embedUri'	=> $g2EmbedUri,
			'apiVersion'	=> $g2ApiVersion,
			'fullInit'	=> $fullInit,
			'loginRedirect'	=> $pref['g2mOptions']['Loginredirect'],
			'activeUserId'	=> intval($activeuser),
			'activeLanguage'=> $lng->convert(e_LANGUAGE),
		));


//		GalleryCoreApi::setPluginParameter('module', 'core', 'default.language', $lng->convert(e_LANGUAGE));

		// check if the right database is selected 
		$this->g2_CheckDb();

		return $this->ret;
	}
	
	//////////////////////////////////////////
	// Tell gallery we are done and reconnect to e107 database
	//////////////////////////////////////////
	function g2_Close()
	{
		// Tell gallery we are done
		GalleryEmbed::done();
		// Reconnect to the e107 database for following db queries;
		$this->e107_ConnectDb();

		if(isset($_POST))
			reset($_POST);
	}
	
	//////////////////////////////////////////
	// Update or create a gallery2 user
	//////////////////////////////////////////
	function g2_ChangeOrCreateUser($userid, $g2user)
	{
		// Check if the e107 user is mapped to a gallery user
		$ret = GalleryEmbed::isExternalIdMapped( $userid, 'GalleryUser' );
	
		// Create User if the user not exists
		if ($ret && ($ret->getErrorCode() & ERROR_MISSING_OBJECT) > 0)
		{
			$ret = GalleryEmbed::createUser($userid, $g2user);
			if ($ret)
			{
				if (($ret->getErrorCode() & ERROR_COLLISION) > 0)
					$error = LAN_G2M_CLASS_USER_EXIST;
				else
					$error = LAN_G2M_CLASS_CREATE_USER."<br />".$ret->getAsHtml();
			}
		// TODO: we have to handle errors elsewhere
		} // Update User if allready present
		else if (!$ret)
		{
			$ret = GalleryEmbed::updateUser($userid, $g2user);
			if ($ret)
			{
				if (($ret->getErrorCode() & ERROR_MISSING_OBJECT) > 0)
					$error = LAN_G2M_CLASS_ERROR_MAPPING;
				else
					$error = LAN_G2M_CLASS_UPDATE_USER."<br />".$ret->getAsHtml();
			}
		}
		else
			$error .= $ret->getAsHtml();
	
		return $error;
	}
	
	//////////////////////////////////////////
	// Load the e107 user data into a g2user array
	//////////////////////////////////////////
	function e107_LoadUserData($where)
	{
		$sql = new db;
		$sql->db_Select("user", "user_id, user_loginname, user_name, user_email", $where, true);
		list($userid, $loginname, $username, $useremail) = $sql->db_Fetch();
	
		$g2user = array(
			'username'	=> $loginname,
			'email'		=> $useremail,
			'fullname'	=> $username
		);
	
		return array ($userid, $g2user);
	}
	
	//////////////////////////////////////////
	// Reconnect to the e107 database
	//////////////////////////////////////////
	function e107_ConnectDb()
	{
		global $mySQLserver, $mySQLuser, $mySQLpassword, $mySQLdefaultdb, $sql;
	
		if (!is_a($sql, 'db'))
		{
			$sql = new db;
		}
		$sql -> db_Connect($mySQLserver, $mySQLuser, $mySQLpassword, $mySQLdefaultdb);
	}
	
	//////////////////////////////////////////
	// check if the right database is selected 
	// (work around for the ERROR_STORAGE_FAILURE)
	//////////////////////////////////////////
	function g2_CheckDb()
	{
		global $gallery;
	
		if (isset($gallery) && $storage = $gallery->getStorage())
		{
			$db_configured  = $storage->_database;
			if ($db_configured && isset($storage->_db))
			{
				$record = $storage->_db->Execute('SELECT DATABASE()');
				if ($record)
					list($db_selected) = $record->FetchRow();
				if ($db_configured != $db_selected)
					$storage->_db->SelectDB($db_configured);
			}
		}
	}

	function g2_getimageblock($id = 1)
	{
		global $pref;

		if(!$this->ret)
		{
			if($id == 0 || $id > $pref['g2mOptions']['NbrBlock'])
				$id = 1;

			while(list($key, $val) = each($pref['g2mOptions']['Block_'.$id]['BlockType']))
				$BlockType .= $key . "|";

			while(list($key, $val) = each($pref['g2mOptions']['Block_'.$id]['BlockShow']))
				$BlockShow .= $key . "|";

			$ItemId = $pref['g2mOptions']['Block_'.$id]['ItemId'];
			if ($ItemId == "")
				$ItemId = NULL;

			$maxSize = $pref['g2mOptions']['Block_'.$id]['maxSize'];
			if($maxSize == "")
				$maxSize = NULL;

			$exactSize = $pref['g2mOptions']['Block_'.$id]['exactSize'];
			if($exactSize == "")
				$exactSize = NULL;

			$repeatBlock = $pref['g2mOptions']['Block_'.$id]['repeatBlock'];
			if($repeatBlock == "")
				$repeatBlock = 1;

			list($this->ret, $this->blockdata['Block_'.$id]['blockHtml'], $this->blockdata['Block_'.$id]['headHtml']) = GalleryEmbed::getImageBlock(array(
				'blocks'	=> $BlockType,
				'show'		=> $BlockShow,
				'maxSize'	=> intval($maxSize),
				'exactSize'	=> intval($exactSize),
				'repeatBlock'	=> intval($repeatBlock),
				'itemId'	=> $ItemId,
				'link'		=> $pref['g2mOptions']['Block_'.$id]['link'],
				'linkTarget'	=> $pref['g2mOptions']['Block_'.$id]['linkTarget']));

			if ($this->ret)
			{
				if (($this->ret->getErrorCode() & ERROR_CONFIGURATION_REQUIRED) > 0)
					$this->blockdata['Block_'.$id]['blockHtml'] = LAN_G2M_CLASS_ACTIVATE_BLOCK;
				else
					$this->blockdata['Block_'.$id]['blockHtml'] = g2_getErrorStr();;
			}
		}
	}

	function g2_getErrorStr()
	{
		$errorCode = $this->ret->getErrorCodeConstants($this->ret->getErrorCode());
		return LAN_G2M_CLASS_GET_IMAGE.'<br />'.
			'ErrorCode: '.$errorCode[0].'('.$this->ret->getErrorCode().')<br />'.
			'ErrorMessage: '.$this->ret->getErrorMessage().'<br />';
	}
}

?>